import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;

public class Gui extends Frame
{
	String fileName = "vocab.txt"; //file name to be read from
	VocabList vocab; //vocab list
	String saveTo = "vocab.txt"; //file name to save to
	int numberOfChoice;
	int numberOfVocab;
	int period; //check the new vocab to be different from the last one period. (>1)
	
	
	//Define Color-----------------------------------------------------------
	public static Color back = new Color(236,233,216); //grey background
	public static Color highlight = new Color(209,206,229); //highlight
	public static Color backv = new Color(232,230,255); //vocab background
	public static Color backB = new Color(205,250,253); //button background
	public static Color backB1 = new Color(252,205,248); //button background
	public static Color backB2 = new Color(205,250,253); //button background
	public static Color backVPanel = new Color(232,230,255); //vocab Panel background
	public static Color taC = new Color(255,230,230); //ta color
	public static Color ta2C = new Color(224,255,226); //ta2 color
	//-----------------------------------------------------------------------
	
	TextArea ta; //text area for diaplaying dialogue messages
	Label ta2; //text area for diaplaying vocab (question)
	PanelC ChoiceArea;
	
    public Gui()
    {
        super("Din Vocab");
		//---------------------------------------------------------------------------------
		//Load configuration and data
		
		try
		{
			loadConfig();
			vocab = new VocabList(fileName);
			numberOfVocab = vocab.size();
		}
		catch(IOException e){System.out.println("IO Error");}
		finally{}
	
		//Because period = #different vocab. Then need at least period+1 vocab. or period 
		//has to be less than or equal to numberOfVocab-1
		if(period > numberOfVocab-1)
		{
			MessageFrame alert = new MessageFrame("Alert", "Too big period. Use " + (numberOfVocab-1) + " instead");
			period = numberOfVocab-1;
		}
		//----------------------------------------------------------------------------------
		
        addWindowListener(new WindowAdapter(){public void windowClosing(WindowEvent event){dispose(); System.exit(0);}});
        setBackground(back);

        ta = new TextArea("Welcome To Din's Vocab Test!",3,100,TextArea.SCROLLBARS_BOTH);
		ta.append("\n\tThe " + fileName + " file currently has " + numberOfVocab + " words");
		ta.setBackground(taC);
        ta.setEditable(false);
        add(ta, BorderLayout.NORTH);
		ta2 = new Label("Vocab");
		ta2.setBackground(ta2C);
        add(ta2, BorderLayout.CENTER);
		
		ChoiceArea = new PanelC(this);
		
		
        add(ChoiceArea, BorderLayout.SOUTH);
        
		pack(); setVisible(true);
		
		//Generate the first set of test
		ChoiceArea.setVocab();
    }
	public void loadConfig() throws IOException, FileNotFoundException
	{
		File f = new File(VocabF.FileConfig);
		FileReader fr = new FileReader(f);
		BufferedReader br = new BufferedReader(fr);
		
		fileName = br.readLine();
		saveTo = br.readLine();
		numberOfChoice = new Integer(br.readLine()).intValue();
		period = new Integer(br.readLine()).intValue();
		
		br.close();
	}
}
