import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;

class PanelC extends Panel implements ActionListener
{
	Gui gui;
	//To be read from Gui
	String fileName = "vocab.txt"; //file name to be read from
	VocabList vocab; //vocab array
	String saveTo = "vocab.txt"; //file name to save to
	int numberOfChoice;
	int numberOfVocab;
	int period;
	
	//Create checkboxes for holding vocab choices
	CheckboxGroup group = new CheckboxGroup();
	Checkbox[] choice;
	//Create control panel's buttons
	Panel buttonPanel = new Panel();
	Panel buttonPanel1 = new Panel();
	Panel buttonPanel2 = new Panel();
	Button check = new Button("Check my answer.");
	Button next = new Button("Next one please.");
	Button printall = new Button("Show all vocab");
	Button reset = new Button("Reset Score");
	Button showfile = new Button("Edit text file");
	Button option = new Button("Option...");
	
	int nVocab; //vocab position
	int indexAns = 0; //checkbox which hold the correct answer
	//score keeping
	int correct = 0;
	int total = 0;
	//vocab use keeping
	int vocabuse[];
	int indexarray = 0;
	
	static Random ranNum = new Random();
	
	PanelC(Gui guii)
	{
		gui = guii;
		//transfer info from gui
		fileName = gui.fileName;
		vocab = gui.vocab;
		saveTo = gui.saveTo;
		numberOfChoice = gui.numberOfChoice;
		numberOfVocab = gui.numberOfVocab;
		period = gui.period;
		
		vocabuse = new int[period];
		ArrayM.setAllValue(vocabuse, -1);
		
		choice = new Checkbox[numberOfChoice];
		
		setBackground(Gui.backVPanel);
		setLayout(new GridLayout(numberOfChoice+1,1,5,5));
		//Add components (checkboxes, control buttons)
		for(int i = 0; i < numberOfChoice; i++)
		{
			choice[i] = new Checkbox("Choice",group, false);
			add(choice[i]);
		}
		
		buttonPanel.setBackground(Gui.backB);
		
		buttonPanel1.setBackground(Gui.backB1);
		buttonPanel2.setBackground(Gui.backB2);
		buttonPanel1.add(check);
		buttonPanel1.add(next);
		
		buttonPanel2.add(reset);
		buttonPanel2.add(printall);
			
		buttonPanel2.add(showfile);
		buttonPanel2.add(option);
		buttonPanel.add(buttonPanel1);
		buttonPanel.add(buttonPanel2);
		
		add(buttonPanel);
		//Add ActionListener to all button
		check.addActionListener(this);
		next.addActionListener(this);
		printall.addActionListener(this);
		reset.addActionListener(this);
		showfile.addActionListener(this);
		option.addActionListener(this);
	}
	public void actionPerformed(ActionEvent e)
	{
		if(e.getSource()==check)
		{
			check();
		}
		else if(e.getSource()==next)
		{
			setVocab();
		}
		else if(e.getSource()==printall)
		{
			printAllVocab();
		}
		else if(e.getSource()==reset)
		{
			reset();
		}
		else if(e.getSource()==showfile)
		{
			showfile();
		}
		else if(e.getSource()==option)
		{
			OptionGui OG = new OptionGui(gui);
		}
	}
	//reset score
	public void reset()
	{
		correct = 0;
		total = 0;
		gui.ta.setText("\nReset!\tYour stat: correct " + correct + "/" + total + " = " + 0 + "%");
		setVocab();
	}
	//check answer
	public void check()
	{
		total = total+1;
		int check = 0;
		//Find out which checkbox is selected
		for(int i=0; i<numberOfChoice; i++)
		{
			if(choice[i].getState()==true)
			{
				check = i;
			}
		}
		//Check with the correct answer and tell the result
		if(check == indexAns)
		{
			gui.ta.setText("\nCorrect!\t");
			correct++;
		}
		else
		{
			gui.ta.setText("\nNooo!\t");
		}
		//Show stat
		gui.ta.append("Your stat: correct " + correct + "/" + total + " = " + (int)(correct*100/total) + "%");
		choice[indexAns].setBackground(Gui.highlight);
		repaint();
	}
	//set the multiple choices questions
	public void setVocab()
	{
		int[] indexCUsed = {}; //index of the checkbox(es) that is/are already used (filled with def.)
		int[] indexVUsed = {}; //index of the vocab that are already used as the true match or as choices
		
		//true vocab
		//choose the where the answer is among the checkbox positions.
		indexAns = (int)Math.floor(numberOfChoice*ranNum.nextDouble());
		//choose vocab
		nVocab = ArrayM.randIntNotIn(vocabuse,0,numberOfVocab-1);
		
		//save current index vocab into the list of already used vocab
		vocabuse[indexarray] = nVocab;
		indexarray = (indexarray+1)%period;
		
		//to test what are in the int array, use this line
		//System.out.println(ArrayM.int2string(vocabuse," "));
		
		//Display the vocab on the text area
		gui.ta2.setText(vocab.getVocab(nVocab));
		
		//Display the correct Def on one choice
		choice[indexAns].setLabel(vocab.getDef(nVocab));
		choice[indexAns].setBackground(Gui.backv);
		
		//Keep track of which checkbox and vocab is already used.
		indexCUsed = ArrayM.addInt(indexCUsed, indexAns);
		indexVUsed = ArrayM.addInt(indexVUsed, nVocab);
				
		//rest of choices
		for(int i = 0; i < numberOfChoice-1; i++)
		{
			//choose random vocab meaning
			int posM = ArrayM.randIntNotIn(indexVUsed,0,numberOfVocab-1);
			indexVUsed = ArrayM.addInt(indexVUsed, posM);
			int posC = ArrayM.intNotIn(indexCUsed,0,numberOfChoice-1);
			indexCUsed = ArrayM.addInt(indexCUsed, posC);
			choice[posC].setLabel(vocab.getDef(posM));
			choice[posC].setBackground(Gui.backv);
		}		
	}
	public void printAllVocab()
	{
		TextFrame AllVocab = new TextFrame("Vocab List",30);
		AllVocab.ta.append(vocab.toString());
		//AllVocab.ta.append(ArrayM.array2string(vocab,"\n\t","\n"));
		
	}
	public void showfile()
	{
		FileFrame AllVocab = new FileFrame("Vocab File",30, saveTo);
		try
		{
			AllVocab.ta.append(FileM.file2string(fileName));
		}
		catch(IOException e1){}
		//catch(FileNotFoundException e2){}
		finally{}
	}
}
//--------------------------------------------------------------------------------------------
class FileFrame extends Frame implements ActionListener
{
		String SaveTo = "x.txt";
		Panel pp = new Panel();
		Button save = new Button("Save");
		TextArea ta; //text area for diaplaying information	
		public FileFrame(String name, int rows, String saveTo)
		{
			super(name);
			SaveTo = saveTo;
			addWindowListener(new WindowAdapter(){public void windowClosing(WindowEvent event){dispose();}});
            //Event Listeners as Anonymous Inner Class      
			setBackground(Gui.back);
			ta = new TextArea("",rows,100,TextArea.SCROLLBARS_BOTH);
			save.addActionListener(this);
			add(pp);
			pp.add(ta);
			pp.add(save);
			pack();
			setVisible(true);
		}
		public void append(String text)
		{
			ta.append(text);
		}
		public void actionPerformed(ActionEvent e)
		{
			if(e.getSource()==save)
			{
				String toFile = ta.getText();
				try{FileM.string2file(toFile,SaveTo);}
				catch(IOException exp){}
				finally{}
			}
		}
}