import java.io.*;
import java.util.*;

class VocabList extends LinkedList
{
	VocabList()
	{
		super();
		//System.out.println("Created");
	}
	VocabList(String fileName) throws IOException
	{
		int minL = 2; //minimum character of a valid line.
		File f = new File(fileName);
		FileReader fr = new FileReader(f);
		BufferedReader br = new BufferedReader(fr);
			//read information from the file line by line
		String input = br.readLine();
		while(input!=null && input.length() > minL)
		{
			int seperatePosition = input.indexOf(',');
			add(input.substring(0,seperatePosition),input.substring(seperatePosition+3));
			input = br.readLine();
		}
		br.close();
	}
	public void add(String vocab, String def)
	{
		add(new VocabInfo(vocab, def));
	}
	public String toString()
	{
		String out = "";
		int L = size();
		for(int i=0;i<L-1;i++)
		{
			out = out+get(i).toString()+"\n";
		}
		out = out+get(L-1).toString();
		return out;
	}
	public String toString(String col, String row)
	{
		String out = "";
		int L = size();
		for(int i=0;i<L-1;i++)
		{
			out = out+((VocabInfo)get(i)).toString(col)+row;
		}
		out = out+((VocabInfo)get(L-1)).toString(col);
		return out;
	}
	public String getVocab(int i)
	{
		return ((VocabInfo)get(i)).getVocab();
	}
	public String getDef(int i)
	{
		return ((VocabInfo)get(i)).getDef();
	}
	public void print()
	{
		for(int i=0;i<size();i++)
		{
			System.out.println(getVocab(i) + " " + getDef(i));
		}
	}
	//Load vocab list
	public void load(String fileName) throws IOException, FileNotFoundException
	{
		int minL = 2; //minimum character of a valid line.
		File f = new File(fileName);
		FileReader fr = new FileReader(f);
		BufferedReader br = new BufferedReader(fr);
			//read information from the file line by line
		String input = br.readLine();
		while(input!=null && input.length() > minL)
		{
			int seperatePosition = input.indexOf(',');
			add(input.substring(0,seperatePosition),input.substring(seperatePosition+3));
			input = br.readLine();
		}
		br.close();		
	}
}
class VocabInfo
{
	String vocab;
	String def;
	public VocabInfo()
	{
		vocab = "";
		def = "";
	}
	public VocabInfo(String Vocab)
	{
		vocab = Vocab;
	}
	public VocabInfo(String Vocab, String Def)
	{
		vocab = Vocab;
		def = Def;
	}
	public String getVocab()
	{
		return vocab;
	}
	public String getDef()
	{
		return def;
	}
	public String toString()
	{
		return vocab+"\t"+def;
	}
	public String toString(String btw)
	{
		return vocab+btw+def;
	}
}
